#define __STDC_FORMAT_MACROS
#include <sys/types.h>
#include <inttypes.h>
#include <fcntl.h>

#include "config.h"
#include "aftimer.h"
#include "bloom.h"
#include "sha1_t.h"

#include "threaded_hash.h"

/* how fast is the threaded hash? */

int main(int argc,char **argv)
{
    OpenSSL_add_all_digests();

    printf("attempting empty sha1\n");
    {
	threaded_hash s(EVP_get_digestbyname("sha1"),1);
    }
	    

    int count = 1;
    for(int p=0;p<7;p++){
	for(int threaded=0;threaded<2;threaded++){
	    u_char buf[65536];
	    memset(buf,'A',sizeof(buf));

	    aftimer aft;
	    aft.start();
	    threaded_hash sha1(EVP_get_digestbyname("sha1"),threaded);
	    threaded_hash sha2(EVP_get_digestbyname("sha256"),threaded);
	    for(int i=0;i<count;i++){
		buf[0] = i%256;
		sha1.update(buf,sizeof(buf));
		sha2.update(buf,sizeof(buf));
	    }
	    sha1.hexhash();		// force the calculation
	    sha2.hexhash();
	    aft.stop();
	    printf("Threaded: %d\n",threaded);
	    printf(" t=%.4g bytes=%zd max_in_worklist==%"PRId64" sha1: %s\n",
		   aft.elapsed_seconds(),sha1.hashed_bytes,sha1.max_bytes_in_worklist,sha1.hexhash());
	    printf(" t=%.4g bytes=%zd max_in_worklist==%"PRId64" sha256: %s\n",
		   aft.elapsed_seconds(),sha2.hashed_bytes,sha2.max_bytes_in_worklist,sha2.hexhash());
	}
	count = count*10;
	printf("==\n");
    }
}

